package com.vp.plugin.sample.nicknameplugin.actions;

import com.vp.plugin.*;
import com.vp.plugin.action.*;
import com.vp.plugin.model.*;

public class SwitchToNextNicknameActionController implements VPActionController {
	
	public void performAction(VPAction aArg0) {
		
		// Getting Project's Nicknames
		IProject lProject = ApplicationManager.instance().getProjectManager().getProject();
		String[] lNicknames = lProject.getNicknames();
		int lCount = lNicknames == null ? 0 : lNicknames.length;
		if (lCount == 0) {
			ApplicationManager.instance().getViewManager().showMessage("No nickname defined in project.");
		}
		else {
			String lNickname = lProject.getNickname();
			int lNicknameIndex;
			if (lNickname == null || lNickname.length() == 0 || "Realname".equals(lNickname)) {
				// using 'real name' (or 'original name'), change to use first nickname
				lNicknameIndex = 0;
			}
			else {
				lNicknameIndex = -1;
				for (int i = 0; i < lCount; i++) {
					if (lNickname.equals(lNicknames[i])) {
						lNicknameIndex = i;
						break;
					}
				}
				if (lNicknameIndex == -1) {
				}
				else {
					lNicknameIndex++; // next nickname.
				}
			}
			
			if (lNicknameIndex == -1) {
				ApplicationManager.instance().getViewManager().showMessage("[Error] Current nickname is not one of project's nicknames? " + lNickname);
			}
			else if (lNicknameIndex == lCount) {
				ApplicationManager.instance().getViewManager().showMessage("Switch to real name");
				lProject.setNickname(null); // no more next nickname, switch to 'real name'
			}
			else {
				ApplicationManager.instance().getViewManager().showMessage("Switch to \""+lNicknames[lNicknameIndex]+"\"");
				lProject.setNickname(lNicknames[lNicknameIndex]); // switch to next nickname
			}
			
		}
		
	}

	public void update(VPAction aArg0) {
	}

}
